// Functions for easy use of LEDs (LED0..7) on Kamami KAMeLeon STM32L496 board.
// jk 11'2017
// The initialization code was generated in STM32CubeMX.

#include "kamami_l496_led.h"
#include "stm32l4xx_hal.h"

#define LED0_Pin GPIO_PIN_6
#define LED0_GPIO_Port GPIOC
#define LED1_Pin GPIO_PIN_7
#define LED1_GPIO_Port GPIOC
#define LED2_Pin GPIO_PIN_8
#define LED2_GPIO_Port GPIOC
#define LED3_Pin GPIO_PIN_9
#define LED3_GPIO_Port GPIOC
#define LED4_Pin GPIO_PIN_4
#define LED4_GPIO_Port GPIOE
#define LED5_Pin GPIO_PIN_3
#define LED5_GPIO_Port GPIOD
#define LED6_Pin GPIO_PIN_5
#define LED6_GPIO_Port GPIOE
#define LED7_Pin GPIO_PIN_6
#define LED7_GPIO_Port GPIOE

// as the LEDs are not all on the same port, the table below provides mapping 
// from LED number to the port and pin it is connected to
struct led_def_ {
	GPIO_TypeDef* port;
	uint16_t pin;
};

struct led_def_ led_defs[8] = {
	LED0_GPIO_Port, LED0_Pin,
	LED1_GPIO_Port, LED1_Pin,
	LED2_GPIO_Port, LED2_Pin,
	LED3_GPIO_Port, LED3_Pin,
	LED4_GPIO_Port, LED4_Pin,
	LED5_GPIO_Port, LED5_Pin,
	LED6_GPIO_Port, LED6_Pin,
	LED7_GPIO_Port, LED7_Pin,	
};

void led_init(void)
{
  GPIO_InitTypeDef GPIO_InitStruct;

  /* GPIO Ports Clock Enable */
  __HAL_RCC_GPIOE_CLK_ENABLE();
  __HAL_RCC_GPIOC_CLK_ENABLE();
  __HAL_RCC_GPIOD_CLK_ENABLE();

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOE, LED4_Pin|LED6_Pin|LED7_Pin, GPIO_PIN_RESET);

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOC, LED0_Pin|LED1_Pin|LED2_Pin|LED3_Pin, GPIO_PIN_RESET);

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(LED5_GPIO_Port, LED5_Pin, GPIO_PIN_RESET);

  /*Configure GPIO pins : LED4_Pin LED6_Pin LED7_Pin */
  GPIO_InitStruct.Pin = LED4_Pin|LED6_Pin|LED7_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(GPIOE, &GPIO_InitStruct);

  /*Configure GPIO pins : LED0_Pin LED1_Pin LED2_Pin LED3_Pin */
  GPIO_InitStruct.Pin = LED0_Pin|LED1_Pin|LED2_Pin|LED3_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(GPIOC, &GPIO_InitStruct);

  /*Configure GPIO pin : LED5_Pin */
  GPIO_InitStruct.Pin = LED5_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(LED5_GPIO_Port, &GPIO_InitStruct);	
}

void led_on(uint8_t led_num)
{
	HAL_GPIO_WritePin(led_defs[led_num].port, led_defs[led_num].pin, GPIO_PIN_SET);
}

void led_off(uint8_t led_num)
{
	HAL_GPIO_WritePin(led_defs[led_num].port, led_defs[led_num].pin, GPIO_PIN_RESET);
}

void led_toggle(uint8_t led_num)
{
	HAL_GPIO_TogglePin(led_defs[led_num].port, led_defs[led_num].pin);
}

void led_set_mul(uint8_t led_msk)
{
	for(uint32_t i = 0; i < 8; ++i)
	{
		HAL_GPIO_WritePin(led_defs[i].port, led_defs[i].pin, (led_msk >> i) & 1 ? GPIO_PIN_SET : GPIO_PIN_RESET);
	}
}

void led_on_mul(uint8_t led_msk)
{
	for(uint32_t i = 0; i < 8; ++i)
	{
		if((led_msk >> i) & 1)
			HAL_GPIO_WritePin(led_defs[i].port, led_defs[i].pin, GPIO_PIN_SET);
	}
}

void led_off_mul(uint8_t led_msk)
{
	for(uint32_t i = 0; i < 8; ++i)
	{
		if((led_msk >> i) & 1)
			HAL_GPIO_WritePin(led_defs[i].port, led_defs[i].pin, GPIO_PIN_RESET);
	}
}

void led_toggle_mul(uint8_t led_msk)
{
	for(uint32_t i = 0; i < 8; ++i)
	{
		if((led_msk >> i) & 1)
			HAL_GPIO_TogglePin(led_defs[i].port, led_defs[i].pin);
	}
}
