// Functions for easy use of 4-digit 7-segment display on Kamami KAMeLeon STM32L496 board.
// jk 11'2017

#ifndef	_KAMAMI_L496_MOTOR_H
#define	_KAMAMI_L496_MOTOR_H
#include <stdint.h>

#define MOTOR_DIR_CLOCKWISE				0
#define MOTOR_DIR_COUNTERCLOCKWISE		1

/* Initialize motor control. 
 * The function should be called before using any other motor function. 
 * It initializes GPIO lines and timer used for PWM generation. */
void motor_init(void);

/* Turn the motor on (sets ENABLE line to 1). */
void motor_on(void);

/* Turn the motor off (sets ENABLE line to 0). */
void motor_off(void);

/* Set motor rotation direction. 
 * @param dir: motor rotation direction - should be one of the values: MOTOR_DIR_CLOCKWISE and MOTOR_DIR_COUNTERCLOCKWISE. */
void motor_set_dir(uint8_t dir);

/* Set motor rotation speed.
 * @param speed: motor rotation speed in range 0 (no rotation) to 100 (full speed). */
void motor_set_speed(uint8_t speed);

#endif
