// Functions for easy use of LM75 temperature sensor on Kamami KAMeLeon STM32L496 board.
// jk 11'2017

#ifndef	_KAMAMI_L496_TEMP_H
#define	_KAMAMI_L496_TEMP_H
#include <stdint.h>

/* Initialize LM75 temperature sensor. 
 * The function should be called before using any other LM75 temperature sensor function. 
 * It initializes GPIO lines and I2C interface used to communicate with the sensor. */
void temp_lm75_init(void);

/* Read the temperature in degrees Celsius from LM75 temperature sensor. 
 * @retval Temperature in degrees Celsius */
int8_t temp_lm75_read(void);

#endif
