// Functions for easy use of USB VCOM on Kamami KAMeLeon STM32L496 board.
// Works with STM32CubeMX generated USB CDC code.
// jk 11'2017

#ifndef	_KAMAMI_L496_VCOM_H
#define	_KAMAMI_L496_VCOM_H
#include <stdint.h>

/* Initialize  USB VCOM. 
 * The function should be called before using any other USB VCOM function. 
 * It initializes interrupt used for sending VCOM data. */
void vcom_init(void);

/* Send data over USB VCOM. The function blocks until data can be forwarded 
 * to the USB to be transmited.
 * @param buf: pointer to data to send
 * @param len: number of bytes to send */
void vcom_send(uint8_t* buf, uint32_t len);

#endif
